<?php global $APP_KEY, $APP_SECRET;
$APP_KEY='006c86cf46a8e6970145946dd3fab3c5';
$APP_SECRET='8e2fbf4a54edb34e';
require_once(dirname(__FILE__).'/../OAuth.php');

/** 
 * 豆瓣 OAuth 认证类 
 * 
 * @package sae 
 * @author Easy Chen 
 * @version 1.0 
 */ 
class doubanOAuth {/*{{{*/
	/* Contains the last HTTP status code returned */
	private $http_status;

	/* Contains the last API call */
	private $last_api_call;

	/* Set up the API root URL */
	public static $TO_API_ROOT = "http://www.douban.com/service";

	/**
	 * Set API URLS
	 */
	function requestTokenURL() { return self::$TO_API_ROOT.'/auth/request_token'; }
	function authorizeURL() { return self::$TO_API_ROOT.'/auth/authorize'; }
	function authenticateURL() { return self::$TO_API_ROOT.'/auth/authenticate'; }
	function accessTokenURL() { return self::$TO_API_ROOT.'/auth/access_token'; }

	/**
	 * Debug helpers
	 */
	function lastStatusCode() { return $this->http_status; }
	function lastAPICall() { return $this->last_api_call; }

	/**
	 * construct DoubanOAuth object
	 */
	function __construct($consumer_key, $consumer_secret, $oauth_token = NULL, $oauth_token_secret = NULL) {/*{{{*/
		$this->sha1_method = new OAuthSignatureMethod_HMAC_SHA1();
		$this->consumer = new OAuthConsumer($consumer_key, $consumer_secret);
		if (!empty($oauth_token) || !empty($oauth_token_secret)) {
			$this->token = new OAuthConsumer($oauth_token, $oauth_token_secret);
		} else {
			$this->token = NULL;
		}
	}/*}}}*/


	/**
	 * Get a request_token from Douban
	 *
	 * @returns a key/value array containing oauth_token and oauth_token_secret
	 */
	function getRequestToken() {/*{{{*/
		$r = $this->oAuthRequest($this->requestTokenURL());

		$token = $this->oAuthParseResponse($r);
		$this->token = new OAuthConsumer($token['oauth_token'], $token['oauth_token_secret']);
		return $token;
	}/*}}}*/

	/**
	 * Parse a URL-encoded OAuth response
	 *
	 * @return a key/value array
	 */
	function oAuthParseResponse($responseString) {
		$r = array();
		foreach (explode('&', $responseString) as $param) {
			$pair = explode('=', $param, 2);
			if (count($pair) != 2) continue;
			$r[urldecode($pair[0])] = urldecode($pair[1]);
		}
		return $r;
	}

	/**
	 * Get the authorize URL
	 *
	 * @returns a string
	 */
	function getAuthorizeURL($token, $sign_in_with_Weibo = TRUE , $url) {/*{{{*/
		if (is_array($token)) $token = $token['oauth_token'];
		return $this->authorizeURL() . "?oauth_token={$token}&oauth_callback=" . urlencode($url); 
	}/*}}}*/
	/**
	 * Get the authenticate URL
	 *
	 * @returns a string
	 */
	function getAuthenticateURL($token) {/*{{{*/
		if (is_array($token)) $token = $token['oauth_token'];
		return $this->authenticateURL() . '?oauth_token=' . $token;
	}/*}}}*/

	/**
	 * Exchange the request token and secret for an access token and
	 * secret, to sign API calls.
	 *
	 * @returns array("oauth_token" => the access token,
	 *                "oauth_token_secret" => the access secret)
	 */
	function getAccessToken($token = NULL) {/*{{{*/
		$r = $this->oAuthRequest($this->accessTokenURL());
		$token = $this->oAuthParseResponse($r);
		$this->token = new OAuthConsumer($token['oauth_token'], $token['oauth_token_secret']);
		return $token;
	}/*}}}*/

	/**
	 * Format and sign an OAuth / API request
	 */
	function oAuthRequest($url, $args = array(), $method = NULL, $post_data = NULL) {/*{{{*/
			
		if (empty($method)) $method = empty($args) ? "GET" : "POST";
		$req = OAuthRequest::from_consumer_and_token($this->consumer, $this->token, $method, $url, $args);
		$req->sign_request($this->sha1_method, $this->consumer, $this->token);
		switch ($method) {
			case 'GET': return $this->http($req->to_url());
			case 'POST': return $this->http($req->get_normalized_http_url(),
    		$req->to_header(), $post_data);
		}
	}/*}}}*/

	/**
	 * Make an HTTP request
	 *
	 * @return API results
	 */
	function http($url, $header_str = NULL, $post_data = null) {/*{{{*/
		$ch = curl_init();
		if (defined("CURL_CA_BUNDLE_PATH")) curl_setopt($ch, CURLOPT_CAINFO, CURL_CA_BUNDLE_PATH);
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		if (isset($header_str)) {
			$header = array('Content-Type: application/atom+xml',$header_str);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
		}
		//////////////////////////////////////////////////
		///// Set to 1 to verify Douban's SSL Cert //////
		//////////////////////////////////////////////////
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		if (isset($post_data)) {
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
		}
		$response = curl_exec($ch);
		$this->http_status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		$this->last_api_call = $url;
		curl_close ($ch);
		return $response;
	}/*}}}*/
}/*}}}*/


/*2011.04.12*/
function smc_douban_confirm(){
	global $APP_KEY, $APP_SECRET;
	$to = new doubanOAuth($APP_KEY, $APP_SECRET, $_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
	$tok = $to->getAccessToken($_REQUEST['oauth_verifier']);
	$to = new doubanOAuth($APP_KEY, $APP_SECRET, $tok['oauth_token'], $tok['oauth_token_secret']);
	$weiboInfo = $to->OAuthRequest('http://api.douban.com/people/%40me', array(),'GET');
	if($weiboInfo === false || $weiboInfo === null){
		echo '<script type="text/javascript">window.close();</script>';
		return;
	}
	$weiboInfo = simplexml_load_string($weiboInfo);
	$weibouid=str_replace('http://api.douban.com/people/','',$weiboInfo->id);
	
	smc_douban_login($weibouid.'|'.$weibouid.'|'.$weiboInfo->title.'|http://www.douban.com/people/'.$weibouid.'|'.$tok['oauth_token'] .'|'.$tok['oauth_token_secret']); 
}
function smc_douban_login($Userinfo) {
	$userinfo = explode('|',$Userinfo);
	if(count($userinfo) < 6) {
		wp_die("An error occurred while trying to contact Sina Connect.");
	}
	$userdata = array(
		'user_pass' => wp_generate_password(),
		'user_login' => 'douban_'.$userinfo[1],
		'display_name' => $userinfo[2],
		'user_url' => $userinfo[3],
		'user_email' => $userinfo[1].'@douban.com'
	);
	if(!function_exists('wp_insert_user')){
		include_once( ABSPATH . WPINC . '/registration.php' );
	} 
	$wpuid = get_user_by_login($userdata['user_login']);

	if(!$wpuid){
		if($userinfo[0]){
			$wpuid = wp_insert_user($userdata);
			smc_new_user_email($userdata,'豆瓣');
			if($wpuid){
				$smc_array = array (
					"smcid" => $userinfo[0],
					"smcweibo" => 'douban',
					"oauth_access_token" => $userinfo[4],
					"oauth_access_token_secret" => $userinfo[5],
				);
				update_usermeta($wpuid, 'smcdata', $smc_array);
			}
		}
	} else {
		$smc_array = array (
			"smcid" => $userinfo[0],
			"smcweibo" => 'douban',
			"oauth_access_token" => $userinfo[4],
			"oauth_access_token_secret" => $userinfo[5],
		);
		update_usermeta($wpuid, 'smcdata', $smc_array);
	}
  
	if($wpuid) {
		wp_set_auth_cookie($wpuid, true, false);
		wp_set_current_user($wpuid);
	}
}
function smc_douban_getAccessToken($oauth_verifier,$oauth_token,$token_secret){
	global $APP_KEY, $APP_SECRET;
	$to=new doubanOAuth($APP_KEY, $APP_SECRET, $oauth_token, $token_secret);
	return $to->getAccessToken($oauth_verifier);
}
function smc_douban_weibo_update($data,$thumb,$tok){
	global $APP_KEY, $APP_SECRET;
	$data['tags']=array();
	$content=get_weibo_str_length($data,140,true);
	$to=new doubanOAuth($APP_KEY, $APP_SECRET, $tok['oauth_token'], $tok['oauth_token_secret']);
	$content = '<?xml version="1.0" encoding="UTF-8"?>'.
			'<entry xmlns:ns0="http://www.w3.org/2005/Atom" xmlns:db="http://www.douban.com/xmlns/">'.
			'<content>'.$content.'</content>'.
			'</entry>';
    $resp=$to->OAuthRequest('http://api.douban.com/miniblog/saying', array(), 'POST', $content);
	$resp=@simplexml_load_string($resp);
	if($resp->id){
		$resp=(array)$resp->id;
		return $resp[0];
	}else{
		return false;
	}
}
function smc_douban_weibo_repost($p,$smcdata){//http://api.douban.com/miniblog/641923516
	global $APP_KEY, $APP_SECRET;
	$content=get_comment_str_length($p,140,true);
	if(!$p['weibosync']){
		return smc_douban_weibo_update($content,'',array('oauth_token'=>$smcdata['oauth_access_token'],'oauth_token_secret'=>$smcdata['oauth_access_token_secret']));
	}
	$to=new doubanOAuth($APP_KEY, $APP_SECRET, $smcdata['oauth_access_token'], $smcdata['oauth_access_token_secret']);
	$content1=get_weibo_str_length($p['comment'].' - '.$p['url']);
	$xmlcontent = '<?xml version="1.0" encoding="UTF-8"?>'.
			'<entry>'.
			'<content>'.$content1.'</content>'.
			'</entry>';
    $resp=$to->OAuthRequest($p['weibosync'].'/comments', array(), 'POST', $xmlcontent);
	sleep(2);
	smc_douban_weibo_update($content,'',array('oauth_token'=>$smcdata['oauth_access_token'],'oauth_token_secret'=>$smcdata['oauth_access_token_secret']));
}
function smc_douban_weibo_timeline($r,$tok){
	global $APP_KEY, $APP_SECRET;
	$to=new doubanOAuth($APP_KEY, $APP_SECRET, $tok['oauth_token'], $tok['oauth_token_secret']);
	switch($r['type']){
		case 'user_timeline':$api='http://api.douban.com/people/'.$tok['douban_user_id'].'/miniblog';
							$param=array(
								'max-results'=>$r['number']
							);
							break;
		case 'friends_timeline':
		case 'public_timeline':$api='http://api.douban.com/people/'.$tok['douban_user_id'].'/miniblog/contacts';
							$param=array(
								'max-results'=>$r['number']
							);
							break;
		default:break;
	}
	$resp=$to->OAuthRequest($api, $param, 'GET');
	$resp=@simplexml_load_string($resp);print_r($resp);
	die();
	$resp=@simplexml_load_xml($resp);
	if(is_array($resp)&&$resp[0]['id']){
		$data=array();
		foreach($resp as $w){
			$data[]=array(
				'id'=>$w['id'],
				'text'=>$w['text'],
				'author'=>$w['user']['name'],
				'avatar'=>$w['user']['profile_image_url'],
				'time'=>$w['created_at']
			);
		}
		return $data;
	}else{
		return false;
	}
}
?>