<?php
if(get_option('smc_weibo_options')==''){
	add_action('admin_notices', 'smc_warning');
	function smc_warning(){
		echo '<div class="error"><p>请到<a href="'.menu_page_url('smc_options',false).'">Social Medias Connect</a>更新插件设置</p></div>';
	}
}
add_action('init', 'smc_init');
function smc_init(){
	if (session_id() == "") {
		session_start();
	}
	if(!is_user_logged_in()) {	
        if(isset($_GET['oauth_token'])){
			$weibo=$_SESSION["smc_weibo"];
			switch($weibo){
				case 'sinaweibo':
						include dirname(__FILE__).'/sinaweibo/sinaOAuth.php';
						smc_sina_confirm();
						break;
				case 'qqweibo':
						include dirname(__FILE__).'/qqweibo/qqOAuth.php';
						smc_qq_confirm();
						break;
				case 'douban':
						include dirname(__FILE__).'/douban/doubanOAuth.php';
						smc_douban_confirm();
						break;
				case 'sohuweibo':
						include dirname(__FILE__).'/sohuweibo/sohuOAuth.php';
						smc_sohu_confirm();
						break;
				case '163weibo':
						include dirname(__FILE__).'/163weibo/163OAuth.php';
						smc_163_confirm();
						break;
				case 'twitter':
						include dirname(__FILE__).'/twitter/twitterOAuth.php';
						smc_twitter_confirm();
						break;
				default:break;
			}
        } 
    }
	$smc_opt=get_option('smc_weibo_options');
	if($smc_opt['smc_auto_connect']){
		add_action('comment_form', 'smc_connect');
		add_action("login_form", "smc_connect");
		add_action("comment_form_must_log_in_after", "smc_connect");
	}
}

add_action("wp_head", "smc_wp_head");
add_action("admin_head", "smc_wp_head");
//add_action("admin_head", "smc_wp_css");
add_action("login_head", "smc_wp_head");
function smc_wp_head(){
	$weiboopt=get_option('smc_weibo_options');
    if(is_user_logged_in()) {
        if(isset($_GET['oauth_token'])){
			echo '<script type="text/javascript">window.opener.smc_reload("");window.close();</script>';
       }
	}elseif(empty($weiboopt)||$weiboopt['smc_auto_js']){
		echo '<script type="text/javascript" src="'.(WP_PLUGIN_URL.'/'.dirname(plugin_basename (__FILE__))).'/js/social-medias-connect.js"></script>';
		//echo '<script type="text/javascript">if(window.smcJS){if(window.jQuery)jQuery(document).ready(function(){smcJS.smc("'.htmlspecialchars($weiboopt['smc_weibo_notice']).'");});else smcJS.documentReady(function(){smcJS.smc("'.htmlspecialchars($weiboopt['smc_weibo_notice']).'");});}</script>';
	}
	smc_wp_css();
}
function smc_wp_css(){
	echo '<link rel="stylesheet" media="all" href="'.(WP_PLUGIN_URL.'/'.dirname(plugin_basename (__FILE__))).'/style.css"></link>';
}
$smc_loaded=0;
function smc_connect($args=""){
	$weiboopt=get_option('smc_weibo_options');
	global $smc_loaded;
	$defaults=array(
		"admin"=>"",
		"callback_url"=>"",
		"weibos"=>array(),
		"comment"=>0
	);
	$r = wp_parse_args( $args, $defaults );
	extract( $r );

	if(is_user_logged_in()){
		global $user_ID;
		$smcdata = get_user_meta($user_ID, 'smcdata',true);
		$weibotok=get_option('weibo_access_token');
		if($r['comment']){
			$user = wp_get_current_user();
			$display_name=$user->display_name;
			$_weibo=$smcdata['smcweibo']?$smcdata['smcweibo']:'noweibo';
	?>	<p><?php printf('您已经以 <a class="smc_user_login smc_%1s" href="%2$s"><b>%3$s</b></a> 登录。', $_weibo, get_option('siteurl') . '/wp-admin/profile.php', $display_name); ?> <a href="<?php if(is_front_page()||is_home()||is_archive())echo wp_logout_url(get_option('home'));else echo wp_logout_url(get_permalink()); ?>" title="退出登录">退出</a></p>
	<?php
		}elseif($weibo=$smcdata['smcweibo']){
			$weibo=smc_get_weibo_name($weibo);
?>		<p id="smc_sync" class="smc_button smc_<?php echo $smcdata['smcweibo']; ?>"><input name="post_to_socialmedias" type="checkbox" checked="checked" id="post_to_socialmedias" value="1"  /><label for="post_to_socialmedias">同步到<?php echo $weibo; ?></label></p>
<?php	return;
		}
		if(!$r['admin'])return;
	}else{
		$allows=get_option('smc_allowed_weibo');
	}
	$smc_url = WP_PLUGIN_URL.'/'.dirname(plugin_basename (__FILE__));
	$callback=$r['callback_url']?"&callback_url=".$r['callback_url']:"";
?>
	<script type="text/javascript">
    window.smc_reload=function(){
       var url=location.href.replace(/#.*|&delete.*/i,'')+'#smc_sync';
       location.href = url;
       setTimeout(function(){location.reload()},1300);
    }
	<?php if(!is_user_logged_in()&&(empty($weiboopt)||$weiboopt['smc_auto_js'])){ ?>
			if(window.smcJS){
				if(window.jQuery)jQuery(document).ready(function(){
					smcJS.smc("<?php echo htmlspecialchars($weiboopt['smc_weibo_notice']); ?>",<?php echo $smc_loaded; ?>);
				});
				else smcJS.documentReady(function(){
					smcJS.smc("<?php echo htmlspecialchars($weiboopt['smc_weibo_notice']); ?>",<?php echo $smc_loaded; ?>);
				});
			}
	<?php } ?>
    </script>	
	<ul id="smc_connect_area<?php if($smc_loaded)echo '_'.$smc_loaded; ?>" class="smc_connect_area smc_button"<?php if(!is_user_logged_in()&&(empty($weiboopt)||$weiboopt['smc_auto_js']))echo ' style="display:none;"'; ?>>
		<?php if((isset($weibotok)&&!$weibotok['sinaweibo'])||(isset($allows)&&(empty($allows)||$allows['sinaweibo']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=sinaweibo<?php echo $callback; ?>", "dcWindow","width=800,height=600,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/sina_button.png" alt="使用新浪微博登陆" /></li><?php endif; ?>
		<?php if((isset($weibotok)&&!$weibotok['qqweibo'])||(isset($allows)&&(empty($allows)||$allows['qqweibo']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=qqweibo<?php echo $callback; ?>", "dcWindow","width=840,height=900,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/qq_button.png" alt="使用腾讯微博登陆" /></li><?php endif; ?>
		<?php if((isset($weibotok)&&!$weibotok['sohuweibo'])||(isset($allows)&&(empty($allows)||$allows['sohuweibo']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=sohuweibo<?php echo $callback; ?>", "dcWindow","width=800,height=600,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/sohu_button.png" alt="使用搜狐微博登陆" /></li><?php endif; ?>
		<?php if((isset($weibotok)&&!$weibotok['163weibo'])||(isset($allows)&&(empty($allows)||$allows['163weibo']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=163weibo<?php echo $callback; ?>", "dcWindow","width=800,height=600,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/163_button.png" alt="使用网易微博登陆" /></li><?php endif; ?>
		<?php if((isset($weibotok)&&!$weibotok['douban'])||(isset($allows)&&(empty($allows)||$allows['douban']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=douban<?php echo $callback; ?>", "dcWindow","width=800,height=600,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/douban_button.png" alt="使用豆瓣账号登陆" /></li><?php endif; ?>
		<?php if((isset($weibotok)&&!$weibotok['twitter'])||(isset($allows)&&(empty($allows)||$allows['twitter']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=twitter<?php echo $callback; ?>", "dcWindow","width=800,height=600,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/twitter_button.png" alt="Login with Twitter" /></li><?php endif; ?>
		<?php if(!is_user_logged_in()&&!empty($weiboopt)&&!$weiboopt['smc_auto_js']): ?><li><a href="http://www.qiqiboy.com/plugins/social-medias-connect/" rel="bookmark">我也想要使用此服务</a></li><?php endif; ?>
	</ul>
	<?php if(!is_user_logged_in()&&(empty($weiboopt)||$weiboopt['smc_auto_js'])): ?>
		<a id="smc_weibo_start<?php if($smc_loaded)echo '_'.$smc_loaded; ?>" class="smc_weibo_start smc_btn_<?php echo $weiboopt['smc_btn_img']; ?>" title="绑定账号登陆" rel="nofollow" href="javascript:void(0);"></a>
	<?php endif; ?>
<?php
    $smc_loaded = mt_rand(1,999999999);
}

add_filter("get_avatar", "smc_get_avatar",10,4);
function smc_get_avatar($avatar, $id_or_email='',$size='32') { 
	if ( is_object($id_or_email) ) {
		if ( !empty($id_or_email->user_id) ) {
			$user_id = (int) $id_or_email->user_id;
		}
	} else if( is_numeric($id_or_email) ){
		$user_id = (int)$id_or_email;
	} else {
		$user = get_user_by('email', $id_or_email);
		$user_id = (int) $user->ID;
	}

	if($user_id && $smcdata = get_usermeta($user_id, 'smcdata')){
		$weibo=$smcdata['smcweibo'];
		switch($weibo){
			case 'sinaweibo':
					$out = 'http://tp3.sinaimg.cn/'.$smcdata['smcid'].'/50/1.jpg';
					break;
			case 'qqweibo':
					$out = 'http://app.qlogo.cn/mbloghead/'.$smcdata['smcid'].'/100';
					break;
			case 'douban':
					$out = 'http://img3.douban.com/icon/u'.$smcdata['smcid'].'.jpg';
					break;
			case 'sohuweibo':
			case '163weibo':
			case 'twitter':
					$out = $smcdata['smcid'];
					break;
			default:return $avatar;
		}
		$avatar = "<img alt='' src='{$out}' class='avatar avatar-{$size}' height='{$size}' width='{$size}' />";
		return $avatar;
	}else {
		return $avatar;
	}
}

function sc_sinauser_to_wpuser($scid) {
  return get_user_by_meta('scid', $scid);
}

if(!function_exists('get_user_by_meta')){

	function get_user_by_meta($meta_key, $meta_value) {
	  global $wpdb;
	  $sql = "SELECT user_id FROM $wpdb->usermeta WHERE meta_key = '%s' AND meta_value = '%s'";
	  return $wpdb->get_var($wpdb->prepare($sql, $meta_key, $meta_value));
	}
	
	function get_user_by_login($user_login) {
	  global $wpdb;
	  $sql = "SELECT ID FROM $wpdb->users WHERE user_login = '%s'";
	  return $wpdb->get_var($wpdb->prepare($sql, $user_login));
	}
}

if(!function_exists('connect_login_form_login')){
	add_action("login_form_login", "connect_login_form_login");
	add_action("login_form_register", "connect_login_form_login");
	function connect_login_form_login(){
		if(is_user_logged_in()){
			$redirect_to = admin_url('profile.php');
			wp_safe_redirect($redirect_to);
		}
	}
}

add_action('admin_menu', 'smc_options_add_page');
function smc_options_add_page() {
	add_options_page('SocialMedias Options', '社交媒体网站账号绑定', 'manage_options', 'smc_options', 'smc_options_do_page');
}

function smc_options_do_page() {
	if(isset($_GET['delete_all'])){
		delete_option('weibo_access_token');
		$info='你已经删除了所有绑定！';
	}elseif(isset($_GET['delete'])) {
		$weibotok=get_option('weibo_access_token');
		$weibo=trim($_GET['delete']);
		unset($weibotok[$weibo]);
		update_option('weibo_access_token',$weibotok);
		$info='你已经删除了'.$_GET['weiboname'].'的绑定！';
	}elseif(isset($_GET['oauth_token'])){
		switch($_SESSION["smc_weibo"]){
			case 'sinaweibo':
					include dirname(__FILE__).'/sinaweibo/sinaOAuth.php';
					$tok = smc_sina_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			case 'qqweibo':
					include dirname(__FILE__).'/qqweibo/qqOAuth.php';
					$tok = smc_qq_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			case 'douban':
					include dirname(__FILE__).'/douban/doubanOAuth.php';
					$tok = smc_douban_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			case 'sohuweibo':
					include dirname(__FILE__).'/sohuweibo/sohuOAuth.php';
					$tok = smc_sohu_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			case '163weibo':
					include dirname(__FILE__).'/163weibo/163OAuth.php';
					$tok = smc_163_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			case 'twitter':
					include dirname(__FILE__).'/twitter/twitterOAuth.php';
					$tok = smc_twitter_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			default:return;
		}
		$weibotok=get_option('weibo_access_token');
		$weibotok[$_SESSION["smc_weibo"]]=$tok;
		update_option('weibo_access_token',$weibotok);
	}
	?>
	<div class="wrap" style="-webkit-text-size-adjust:none;">
	<div class="icon32" id="icon-options-general"><br></div>
			<h2>绑定社交网站账号</h2>

            <?php
				if(isset($info)){
					echo "<h3 class='info'>$info</h3>";
				}
				$tok = get_option('weibo_access_token');//print_r($tok);//die();
				$smc_url = WP_PLUGIN_URL.'/'.dirname(plugin_basename (__FILE__));
				if($tok){
					echo '<h3>您已经绑定以下网站: </h3>';
					echo '<div id="weibobind">';
					if($tok['sinaweibo'])echo '<img class="smc_img" src="'.$smc_url.'/images/sina.png" /><a href="'.menu_page_url('smc_options',false).'&delete=sinaweibo&weiboname=新浪微博"><input type="submit" class="button-primary" value="删除新浪微博绑定"></a>';
					if($tok['qqweibo'])echo '<img class="smc_img" src="'.$smc_url.'/images/qq.png" /><a href="'.menu_page_url('smc_options',false).'&delete=qqweibo&weiboname=腾讯微博"><input type="submit" class="button-primary" value="删除腾讯微博绑定"></a>';
					if($tok['sohuweibo'])echo '<img class="smc_img" src="'.$smc_url.'/images/sohu.png" /><a href="'.menu_page_url('smc_options',false).'&delete=sohuweibo&weiboname=搜狐微博"><input type="submit" class="button-primary" value="删除搜狐微博绑定"></a>';
					if($tok['163weibo'])echo '<img class="smc_img" src="'.$smc_url.'/images/163.png" /><a href="'.menu_page_url('smc_options',false).'&delete=163weibo&weiboname=网易微博"><input type="submit" class="button-primary" value="删除网易微博绑定"></a>';
					if($tok['douban'])echo '<img class="smc_img" src="'.$smc_url.'/images/douban.png" /><a href="'.menu_page_url('smc_options',false).'&delete=douban&weiboname=豆瓣微博"><input type="submit" class="button-primary" value="删除豆瓣绑定"></a>';
					if($tok['twitter'])echo '<img class="smc_img" src="'.$smc_url.'/images/twitter.png" /><a href="'.menu_page_url('smc_options',false).'&delete=twitter&weiboname=Twitter"><input type="submit" class="button-primary" value="remove twitter account"></a>';
					echo '</div>';
				}
				if(count($tok)>=6){
					echo '<p>你已经绑定了所有网站，点击下面按钮解除所有绑定</p>';
				}else{
					echo '<p>点击下面的图标，将你的帐号和你的博客绑定，当你的博客更新的时候，会同时更新到新浪微博。</p>';
				}
				smc_connect(array('admin'=>1,'callback_url'=>menu_page_url('smc_options',false)));
				if($tok){
			?>
				<a href="<?php echo menu_page_url('smc_options',false); ?>&delete_all=1"><input type="submit" class="button-primary" value="删除所有绑定"></a>
			<?php
				}

			?><br><br>
			<hr/>
			<div class="icon32" id="icon-options-general"><br></div>
			<h2>使用社交网站账号登陆</h2>
			<?php
				if(isset($_POST['smc_allowed_weibo'])){
					$allows=get_option('smc_allowed_weibo');
					if($allows){
						foreach($allows as $key => $t){
							if(isset($_POST['smc_allowed_'.$key])){
								$allows[$key]='1';
							}else{
								$allows[$key]='0';
							}
						}
						$info1='设置成功！';
						update_option('smc_allowed_weibo',$allows);
					}else{
						$info1='设置失败，请刷新页面重试!';
					}
				}
				$allows = get_option('smc_allowed_weibo');
				if(!$allows||count($allows)<6){
					$_allows=array(
						'sinaweibo'=>'1',
						'qqweibo'=>'1',
						'sohuweibo'=>'1',
						'163weibo'=>'1',
						'douban'=>'1',
						'twitter'=>'0'
					);
					if($allows)$_allows=array_merge($_allows,$allows);
					update_option('smc_allowed_weibo',$_allows);
					$allows=get_option('smc_allowed_weibo');
				}
				/* 微博设置 */
				$opt=get_option('smc_weibo_options');
				$default_opt=array(
						'smc_auto_connect'=>'1',
						'smc_auto_js'=>'1',
						'smc_weibo_notice'=>'使用微博连接登陆后，您在本站的评论将会默认同步到您的微博账户。如果不希望同步，请在评论前去掉选择"同步到XXX微博"选项。',
						'smc_btn_img'=>'1',
						'smc_front_prefix'=>'【博客更新】',
						'smc_end_prefix'=>'【博文修改】',
						'smc_shorturl'=>'',
						'smc_use_short'=>'0',
						'smc_thumb'=>'1',
						'smc_post_format'=>'%%prefix%%%%title%% - %%url%% %%tags%%',
						'smc_comment_format'=>'我对《%%title%%》的观点: %%comment%% - %%url%%'
					);
				if(empty($opt)||count($opt)<count($default_opt)){
					if($opt)$default_opt=array_merge($default_opt,$opt);
					update_option('smc_weibo_options',$default_opt);
					$opt=$default_opt;
				}
				if(isset($_POST['smc_weibo_option'])){
					foreach($opt as $key => $t){
						if(isset($_POST[$key])){
							$opt[$key]=stripslashes($_POST[$key]);
						}
					}
					update_option('smc_weibo_options',$opt);
				}
			?>
			<form action="<?php echo menu_page_url('smc_options',false); ?>" enctype="multipart/form-data" method="post">
				<?php if(isset($info1)){
						echo "<h3 class='info'>$info1</h3>";
					}
				?>
				<h3>勾选允许连接登陆的网站</h3>
				<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">允许的网站请打上勾<br/></th>
							<td>
								<ul id="smc_allow">
								<?php foreach($allows as $key => $t): ?>
									<li class="smc_<?php echo $key; ?>">
										<input type="checkbox" name="smc_allowed_<?php echo $key; ?>"<?php if($t)echo ' checked="checked"'; ?> value="1" />
									</li>
								<?php endforeach; ?>
								</ul>
								<input type="hidden" name="smc_allowed_weibo" value="1" />
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">自动插入社交媒体连接按钮<br/><br/><small>1.如果选择"是"，将会自动在评论表单、登陆界面处插入连接按钮</small><br/><small>2.如果你选择“否”，那么你需要手动在需要显示连接按钮的地方调用<code>&lt;?php if(function_exists('smc_connect'))smc_connect(); ?></code></small></th>
							<td>
								<input type="radio" name="smc_auto_connect"<?php if($opt['smc_auto_connect'])echo ' checked="checked"'; ?> value="1" /><label>是</label>
								<input type="radio" name="smc_auto_connect"<?php if(!$opt['smc_auto_connect'])echo ' checked="checked"'; ?> value="0" /><label>否</label>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">启用浮动面板<br/><br/><small>1.如果选择"是"，将会在一个浮动窗口中显示登陆连接按钮（节省页面空间）</small><br/><small>2.如果你选择“否”，登陆连接按钮将会全部列出（占地方）</small></th>
							<td>
								<input type="radio" name="smc_auto_js"<?php if($opt['smc_auto_js'])echo ' checked="checked"'; ?> value="1" /><label>是</label>
								<input type="radio" name="smc_auto_js"<?php if(!$opt['smc_auto_js'])echo ' checked="checked"'; ?> value="0" /><label>否</label>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">选择按钮样式<br/><small>只有你选择了“启用浮动面板，这项选择才有效</small></th>
							<td>
								<input type="radio" name="smc_btn_img"<?php if($opt['smc_btn_img']=='1')echo ' checked="checked"'; ?> value="1" /><label><img alt="img 1" src="<?php echo $smc_url; ?>/images/smc_1.png"/></label>
								<input type="radio" name="smc_btn_img"<?php if($opt['smc_btn_img']=='2')echo ' checked="checked"'; ?> value="2" /><label><img alt="img 2" src="<?php echo $smc_url; ?>/images/smc_2.png"/></label>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">浮动面板右边提示文字</th>
							<td>
								<textarea name="smc_weibo_notice" cols="50" rows="3" id="smc_weibo_notice" style="width:500px;font-size:12px;" class="code"><?php echo htmlspecialchars($opt['smc_weibo_notice']); ?></textarea>
							</td>
						</tr>
					</tbody>
				</table>
				<h3>同步到微博文字前缀</h3>
				<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">发布新文章时</th>
							<td>
								<input name="smc_front_prefix" class="regular-text" value="<?php echo htmlspecialchars($opt['smc_front_prefix']); ?>" />
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">修改早期文章时</th>
							<td>
								<input name="smc_end_prefix" class="regular-text" value="<?php echo htmlspecialchars($opt['smc_end_prefix']); ?>" />
							</td>
						</tr>
					</tbody>
				</table>
				<h3>短链接api</h3>
				<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">启用url缩短功能<br/><small>如果启用短网址，请务必填写下面的短网址服务api，否则无效。填入的短网址api一定要可用，否则会影响同步。</small></th>
							<td>
								<input type="radio" name="smc_use_short"<?php if($opt['smc_use_short'])echo ' checked="checked"'; ?> value="1" /><label>启用</label>
								<input type="radio" name="smc_use_short"<?php if(!$opt['smc_use_short'])echo ' checked="checked"'; ?> value="0" /><label>关闭</label>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">输入短连接服务的api地址</th>
							<td>
								<input name="smc_shorturl" class="regular-text" value="<?php echo htmlspecialchars($opt['smc_shorturl']); ?>" /><label> 例如：<code>http://myshort.com/api.php?format=simple&action=shorturl&url=</code></label>
							</td>
						</tr>
					</tbody>
				</table>
				<h3>文章同步</h3>
				<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">文章同步格式<br/><br/><small>%%prefix%%: 文章前缀<br/>%%title%%: 文章标题<br/>%%url%%: 文章链接<br/>%%tags%%: 文章标签<br/>%%excerpt%%: 文章摘要</small><br/></th>
							<td>
								<textarea name="smc_post_format" cols="50" rows="3" id="smc_post_format" style="width:500px;font-size:12px;" class="code"><?php echo htmlspecialchars($opt['smc_post_format']); ?></textarea><br/>你可以随意调整标题、链接、标签等的顺序，并且可以插入其他内容
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">同步文章缩略图<br/><small>如果没有设置文章缩略图，那么插件会提取文章中第一张图片进行同步。<br/><br/>如果开启缩略图同步时容易出现500错误或者页面显示不可用，那么请最好暂时停用缩略图同步。</small></th>
							<td>
								<input type="radio" name="smc_thumb"<?php if($opt['smc_thumb'])echo ' checked="checked"'; ?> value="1" /><label>同步文章缩略图</label>
								<input type="radio" name="smc_thumb"<?php if(!$opt['smc_thumb'])echo ' checked="checked"'; ?> value="0" /><label>不同步缩略图</label>
							</td>
						</tr>
					</tbody>
				</table>
				<h3>评论同步</h3>
				<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">评论同步格式<br/><br/><small>%%title%%: 文章标题<br/>%%url%%: 评论链接<br/>%%comment%%: 评论内容</small><br/></th>
							<td>
								<textarea name="smc_comment_format" cols="50" rows="3" id="smc_comment_format" style="width:500px;font-size:12px;" class="code"><?php echo htmlspecialchars($opt['smc_comment_format']); ?></textarea><br/>你可以随意调整标题、链接、标签等的顺序，并且可以插入其他内容
							</td>
						</tr>
					</tbody>
				</table>
				<p class="submit">
					<input type="submit" name="option_save" class="button-primary" value="保存设置" />
					<input type="hidden" name="smc_weibo_option" value="1" />
				</p>
			</form><br><br><br>
			<code>提示：请在文章编辑页面下部找到“同步文章状态”一栏，查看当前文章的同步状态，并选择文章是否同步。<br/> 草稿、私密文章、早期文章不同步。如果要同步，请选择“同步”(私密、草稿无效)。<br/> 有任何问题请与我联系(gtalk&gmail:imqiqiboy@gmail.com,也可博客与我交流:http://www.qiqiboy.com/)</code>
			<br>
			<hr/>
			<div>
				<h3 style="color:red">V1.4 更新：</h3>
				<p>1.新增自定义同步格式，支持文章同步和评论同步的格式自定义。<br/>2.新增同步标签、同步摘要。<br/>
					3.更精确的文字截取，准确截取twitter和国内新浪微博的发布字数<br/></p><br/>
				<h3 style="color:red">V1.3 更新：</h3>
				<p>1.新增连接登陆新增twitter服务。默认关闭。请确认你的主机身在“墙外”再启用twitter连接、同步功能。<br/>2.同步文章新增同步文章缩略图到微博功能。如果没有给文章设置缩略图，那么程序会自动抓取文章中第一张图片<br/>
					3.增加文字截断功能。不用再担心文字过多同步失败了。<br/>4.新增使用短网址api功能。</p>
				<h3>插件信息</h3>
				<p><b>插件名称：</b>Social Medias Connect<br/>
				<b>插件作者：</b>qiqiboy<br/>
				<b>插件地址：</b>wordpress官方下载页面<a href="http://wordpress.org/extend/plugins/social-medias-connect/">WordPress Download</a> | 作者博客发布页面<a href="http://www.qiqiboy.com/plugins/social-medias-connect/">插件发布页面</a><br/>
				<b>插件描述：</b>提供wordpress与各大微博网站的连接登陆功能，以及同步文章信息到微博，转发文章的评论到微博。</p>
				<h3>关于插件的一些FAQ</h3>
				<p>1. 问：启用插件为什么没有任何效果？
					答：请确认评论模板中有<code>&lt;?php do_action('comment_form', $post->ID); ?></code>代码，没有的话要加上。
				</p>
				<p>2. 问：启用插件wordpress报错？
					答：请确认评论wordpress版本>3.0。
				</p>
				<p>3. 问：为什么微博连接注册用户的用户名都是 sina_t_ sohu_t_ 等开头？
					答：为了保证wp既有用户的安全。
				</p>
				<p>4. 问：微博连接能和现有的用户账户绑定吗？
					答：暂时不行。未来会推出微博绑定服务。
				</p>
				<p>5. 问：如何再次同步文章？
					答：请在文章编辑页面找到“同步文章状态”一栏，选择“同步”即可。
				</p>
				<h3>微博与我交流(欢迎Follow我)</h3>
				新浪微博：<a href="http://weibo.com/qiqiboy">@qiqiboy</a><br/>
				腾讯微博：<a href="http://t.qq..com/imqiqiboy">@imqiqiboy</a><br/>
				Twitter：<a href="http://twitter.com/qiqiboy">@qiqiboy</a>
			</div>
	</div></div>
	<?php
}
/* sync your entry to social media sites */
add_action('publish_post', 'smc_publish_post', 999);
function smc_publish_post($post_ID=""){
	if($_POST['smc_must_sync']==='no' || $_POST['action'] == "autosave" || $_POST['action'] == "inline-save" || $_POST['post_status'] == "draft" || $_POST['post_status'] == "private" || isset($_GET['bulk_edit']) || isset($_POST['_inline_edit'])){
		return false;//设定了不发布、自动草稿、保存为草稿、私密文章、快速编辑、批量编辑都不会同步
	}
	$weibotok = get_option('weibo_access_token');
	$weiboopt=get_option('smc_weibo_options');
	if(!$weibotok) return;//未绑定微博
	$_post=get_post($post_ID);
	$thumb=$weiboopt['smc_thumb']?smc_post_thumb($_post):'';//取得图片
	$prefix=$_POST['original_post_status'] == 'publish' || $_POST['original_post_status'] == 'private' ? $weiboopt['smc_end_prefix'] : $weiboopt['smc_front_prefix'];
	$url=get_permalink($post_ID);
	if($weiboopt['smc_use_short']&&$weiboopt['smc_shorturl']){
		$_url=file_get_contents($weiboopt['smc_shorturl'].$url);
		$url=substr($_url,0,7)=="http://"?$_url:$url;
	}
	$excerpt=$_post->post_excerpt?strip_tags($_post->post_excerpt):strip_tags($_post->post_content);
	$content=array('prefix'=>$prefix,'text'=>$_post->post_title,'url'=>wp_urlencode($url),'tags'=>wp_get_post_tags($_post->ID),'excerpt'=>$excerpt);
	foreach($weibotok as $weibo => $tok){
		if(!$_POST['smc_must_sync']&&get_post_meta($post_ID, '_'.$weibo.'_sync', true)){
			continue;
		}
		switch($weibo){
			case 'sinaweibo':
					include dirname(__FILE__).'/sinaweibo/sinaOAuth.php';
					$resp=smc_sina_weibo_update($content,$thumb,$tok);//print_r($resp);
					break;
			case 'qqweibo':
					include dirname(__FILE__).'/qqweibo/qqOAuth.php';
					$resp=smc_qq_weibo_update($content,$thumb,$tok);//print_r($resp);
					break;
			case 'douban':
					include dirname(__FILE__).'/douban/doubanOAuth.php';
					$resp=smc_douban_weibo_update($content,$thumb,$tok);
					break;
			case 'sohuweibo':
					include dirname(__FILE__).'/sohuweibo/sohuOAuth.php';
					$resp=smc_sohu_weibo_update($content,$thumb,$tok);
					break;
			case '163weibo':
					include dirname(__FILE__).'/163weibo/163OAuth.php';
					$resp=smc_163_weibo_update($content,$thumb,$tok);
					break;
			case 'twitter':
					include dirname(__FILE__).'/twitter/twitterOAuth.php';
					$resp=smc_twitter_weibo_update($content,$thumb,$tok);
					break;
			default:break;
		}
		if($resp){
			if(!update_post_meta($post_ID, '_'.$weibo.'_sync', 'true'))
				add_post_meta($post_ID, '_'.$weibo.'_sync', 'true', true);
			if(!update_post_meta($post_ID, '_'.$weibo.'_sync_id', $resp))
				add_post_meta($post_ID, '_'.$weibo.'_sync_id', $resp, true);//9105332181
		}
	}
}
//smc_publish_post(3033);
/* sync comment to social media sites */
add_action('comment_post', 'smc_comment_post',999);
function smc_comment_post($id){
	$comment_post_id = $_POST['comment_post_ID'];
	if(empty($comment_post_id)){
		return;
	}
	$current_comment = get_comment($id);
	$current_post = get_post($comment_post_id);
	$smcdata = get_user_meta($current_comment->user_id, 'smcdata',true);
	$weibo=$smcdata['smcweibo'];
	if($smcdata){
		if($_POST['post_to_socialmedias']){
			$weiboopt=get_option('smc_weibo_options');
			$url=get_permalink($comment_post_id);
			if($weiboopt['smc_use_short']&&$weiboopt['smc_shorturl']){
				$_url=file_get_contents($weiboopt['smc_shorturl'].$url);
				$url=substr($_url,0,7)=="http://"?$_url:$url;
			}
			$p=array(
				"title"=>get_the_title($comment_post_id),
				"url"=>wp_urlencode($url."#comment-".$id),
				"comment"=>strip_tags($current_comment->comment_content),
				"weibosync"=>get_post_meta($comment_post_id, '_'.$weibo.'_sync_id', true)
			);//print_r($p);die();
			switch($smcdata['smcweibo']){
				case 'sinaweibo':
						include dirname(__FILE__).'/sinaweibo/sinaOAuth.php';
						smc_sina_weibo_repost($p,$smcdata);
						break;
				case 'qqweibo':
						include dirname(__FILE__).'/qqweibo/qqOAuth.php';
						smc_qq_weibo_repost($p,$smcdata);
						break;
				case 'douban':
						include dirname(__FILE__).'/douban/doubanOAuth.php';
						smc_douban_weibo_repost($p,$smcdata);
						break;
				case 'sohuweibo':
						include dirname(__FILE__).'/sohuweibo/sohuOAuth.php';
						smc_sohu_weibo_repost($p,$smcdata);
						break;
				case '163weibo':
						include dirname(__FILE__).'/163weibo/163OAuth.php';
						smc_163_weibo_repost($p,$smcdata);
						break;
				case 'twitter':
						include dirname(__FILE__).'/twitter/twitterOAuth.php';
						smc_twitter_weibo_repost($p,$smcdata);
						break;
				default:continue;
			}
		}
	}
}

function smc_weibo_must_sync(){
	global $post;
	$weiboarray=array('qqweibo','sinaweibo','sohuweibo','163weibo','douban','twitter');
	$weibotok=get_option('weibo_access_token');
	$weiboname='';$bindweibo='';
	if($weibotok){
		foreach($weibotok as $weibo => $tok){
			$bindweibo.=' '.($_weibo=smc_get_weibo_name($weibo));
		}
	}
	foreach($weiboarray as $weibo){
		$synced=get_post_meta($post->ID, '_'.$weibo.'_sync', true);
		if($synced){
			$weiboname.=' '.smc_get_weibo_name($weibo);
		}
	}
	$post_status=get_post_status($post->ID);
	switch($post_status){
		case 'publish':$status_info='这篇文章已经发布，默认不会同步。';$synced='true';
						break;
		case 'private':$status_info='这篇文章是私密文章，默认不会同步。';$synced='true';
						break;
		case 'auto-draft':$status_info='这篇文章是您新建的，点击“发布”将会同步到您的绑定微博。';
						break;
		case 'draft':$status_info='这篇文章是您之前保存的草稿，点击“发布”将会同步到您的绑定微博。';
						break;
		default:break;
	}
	echo '<div class="postbox">';
	echo	'<h3 class="hndle"><span>同步文章更新状态('.$status_info.')</span></h3>';
	echo		'<div class="inside">';
	if(!empty($bindweibo)) echo '<p>您已经绑定了{'.$bindweibo.' }。</p>';
	else     echo '<p>您还未绑定任何微博。如果要将文章同步到微博，请立即到<a href="'.menu_page_url('smc_options',false).'">Social Medias Connect</a>设置页面绑定您的微博账号。</p>';
	if(!empty($weiboname)) echo '<p>这篇文章已经同步到了{'.$weiboname.' }。如果你要再次进行同步，请确保选中“同步”状态。</p>';
	else 			echo '<p>这篇文章未同步到任何微博。如果你要进行同步，请确认以选中了“同步按钮。”</p>';
	echo			'<p><b>同步到社交网站: </b><input type="radio" name="smc_must_sync" value="no"';
	if(isset($synced)&&!empty($synced)) echo ' checked="checked"';
	echo 			'/><label>不同步</label> ';
	echo			'<input type="radio" name="smc_must_sync" value="yes"';
	if(!isset($synced)||empty($synced)) echo ' checked="checked"';
	echo 			'/><label>同步</label> <label style="margin-left:30px;">注意，只有选中“同步”状态，才会将文章同步到微博。</label></p>';
	echo		'</div>';
	echo '</div>';
}
//add_action('save_post', 'smc_weibo_action');
add_action('edit_form_advanced', 'smc_weibo_must_sync');

function smc_post_thumb($post=false ){
    if(!$post)global $post;

	$timthumb_src='';
	if( smc_has_post_thumbnail($post->ID)){
		$timthumbs = wp_get_attachment_image_src(smc_get_post_thumbnail_id($post->ID),'full');
		$timthumb_src=$timthumbs[0];
	}else{
		preg_match('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $index_matches);
		$first_img_src = $index_matches [1];
		if($first_img_src){
			$timthumb_src=$first_img_src;
		}
	}
	return $timthumb_src;
}
if(!function_exists('smc_has_post_thumbnail')){
	function smc_has_post_thumbnail( $post_id = NULL ) {
		global $id;
		$post_id = ( NULL === $post_id ) ? $id : $post_id;
		return !! smc_get_post_thumbnail_id( $post_id );
	}
	function smc_get_post_thumbnail_id( $post_id = NULL ) {
		global $id;
		$post_id = ( NULL === $post_id ) ? $id : $post_id;
		return get_post_meta( $post_id, '_thumbnail_id', true );
	}
}
if(!function_exists('wp_urlencode')){
	function wp_urlencode($url) {
		$a = array('%21', '%2A', '%27', '%28', '%29', '%3B', '%3A', '%40', '%26', '%3D', '%2B', '%24', '%2C', '%2F', '%3F', '%23', '%5B', '%5D');
		$b = array('!', '*', "'", "(", ")", ";", ":", "@", "&", "=", "+", "$", ",", "/", "?", "#", "[", "]");
		$url = str_replace($a, $b, urlencode($url));
		return strtolower($url);
	}
}
function smc_get_client_ip(){
	if(getenv('HTTP_CLIENT_IP')){
		$client_ip = getenv('HTTP_CLIENT_IP');
	} elseif(getenv('HTTP_X_FORWARDED_FOR')) {
		$client_ip = getenv('HTTP_X_FORWARDED_FOR');
	} elseif(getenv('REMOTE_ADDR')) {
		$client_ip = getenv('REMOTE_ADDR');
	} else {
		$client_ip = $HTTP_SERVER_VARS['REMOTE_ADDR'];
	}
	return $client_ip;
}
function smc_get_weibo_name($weibo){
	switch($weibo){
		case 'sinaweibo':
				$weibo='新浪微博';
				break;
		case 'qqweibo':
				$weibo='腾讯微博';
				break;
		case 'douban':
				$weibo='豆瓣';
				break;
		case 'sohuweibo':
				$weibo='搜狐微博';
				break;
		case '163weibo':
				$weibo='网易微博';
				break;
		case 'twitter':
				$weibo='Twitter';
				break;
		default:$weibo='XXX微博';
				break;
	}
	return $weibo;
}
function smc_new_user_email($userdata=array(),$name){
	$blogname = get_option('blogname');
	$uname=$userdata['display_name'];
	$ulogin=$userdata['user_login'];
	$uurl=$userdata['user_url'];
	$subj = "新的{$name}连接用户注册 - $blogname";
	$body = "在 $blogname 新注册用户信息：\r\n";
	$body.= "用户名：$ulogin\r\n";
	$body.= "昵称：$uname\r\n";
	$body.= "地址：$uurl\r\n";
	$body.= "\r\n";
	$body.= "-----------------------------------\r\n";
	$body.= "这是一封自动发送的邮件。 \r\n";
	$body.= "来自 {$blogname}。\r\n";
	$body.= "请不要回复本邮件。\r\n";
	$admin_email = get_option('admin_email');
	wp_mail($admin_email, $subj, $body, $headers = '');
}
function smc_strlen($str='',$twitter=false){//twitter和四大微博字数计数方式不一样
	$length = strlen(preg_replace('/[\x00-\x7F]/', '', $str));
    if($twitter){
		if ($length){
			return strlen($str) - $length + intval($length / 3) ;
		}else{
			return strlen($str);
		}
	}else{
		if ($length){
			return (strlen($str) - $length)/2 + intval($length / 3) ;
		}else{
			return strlen($str)/2;
		}
	}
}
/*
function smc_substr($str,$start,$length=false){
	$pa = "/[\x01-\x7f]|[\xc2-\xdf][\x80-\xbf]|\xe0[\xa0-\xbf][\x80-\xbf]|[\xe1-\xef][\x80-\xbf][\x80-\xbf]|\xf0[\x90-\xbf][\x80-\xbf][\x80-\xbf]|[\xf1-\xf7][\x80-\xbf][\x80-\xbf][\x80-\xbf]/";
	preg_match_all($pa, $str, $t_str);
	if(count($t_str[0]) > $length) {
		$str = join('', array_slice($t_str[0], $start, $length));
	}
	return $str;
}
*/
function smc_substr($str, $from=0, $length=false, $old='', $twitter=false){
	$pa = "/[\x01-\x7f]|[\xc2-\xdf][\x80-\xbf]|\xe0[\xa0-\xbf][\x80-\xbf]|[\xe1-\xef][\x80-\xbf][\x80-\xbf]|\xf0[\x90-\xbf][\x80-\xbf][\x80-\xbf]|[\xf1-\xf7][\x80-\xbf][\x80-\xbf][\x80-\xbf]/";
	if(is_array($str)){
		$t_str=$str;
	}else preg_match_all($pa, $str, $t_str);
	if(count($t_str[0]) > $length) {
		$_str = join('', array_slice($t_str[0], $from, $length));
		if(($_length=($length-smc_strlen($_str,$twitter)))>0){
			return smc_substr($t_str,intval($from+$length), intval($_length), $old.$_str, $twitter);
		}
		return $old.$_str;
	}
	return $old.$str;
}
function get_weibo_str_length($data='',$length=140,$twitter=false){
	$weiboopt=get_option('smc_weibo_options');
	$format=$weiboopt['smc_post_format'];
	if(is_array($data)){
		$title=$data['text'];$url=$data['url'];$prefix=$data['prefix'];
		$tags=$data['tags']?smc_convtags($data['tags'],$twitter):array();
		$excerpt=$data['excerpt'];
		if(($url_length=smc_strlen($url,$twitter))>$length)return false;
		$format=str_ireplace('%%title%%',$title,$format);
		$format=str_ireplace('%%prefix%%',$prefix,$format);
		$format=str_ireplace('%%url%%',$url,$format);
		$_format=$format;
		if(($prefix_title_url_length=smc_strlen(preg_replace('/%%tags%%|%%excerpt%%/','',$_format),$twitter))<$length){
			$t_count=0;$new_tags=array();
			if(stripos($format,'%%tags%%')>=0){
				foreach($tags as $tag){
					if($t_count+($_t_count=smc_strlen($tag,$twitter)+1)<$length-$prefix_title_url_length){
						$new_tags[]=$tag;
						$t_count+=$_t_count;
					}else break;
				}
				$format=str_ireplace('%%tags%%',join(' ',$new_tags),$format);
			}else{
				$format=preg_replace('/%%tags%%/','',$format);
			}
			if($excerpt&&($prefix_title_url_tags_length=$prefix_title_url_length+$t_count)<$length-3){
				$format=str_ireplace('%%excerpt%%',smc_substr($excerpt,0,$length-$prefix_title_url_tags_length,'',$twitter).'...',$format);
			}else{
				$format=preg_replace('/%%excerpt%%/','',$format);
			}
		}else{
			$format=smc_substr($prefix.$title,0,$length-$url_length-6).'... - '.$url;
		}
		$_temp=$format;
	}else{
		if(smc_strlen($data,$twitter)>=$length){
			$_temp=smc_substr($data,0,$length-3,'',$twitter).'...';
		}else $_temp=$data;
	}
	return $_temp;
}
function smc_convtags($tags,$twitter=false){
	$output=array();
	foreach($tags as $tag){
		$output[] = '#'. str_ireplace(' ','-',trim($tag->name)) .($twitter?'':'#');
	}
	return $output;
}
function get_comment_str_length($data,$length=140,$twitter=false){
	$weiboopt=get_option('smc_weibo_options');
	$format=$weiboopt['smc_comment_format'];
	$title=$data['title'];$url=$data['url'];$comment=$data['comment'];
	if(($url_length=smc_strlen($url,$twitter))>$length)return false;
	$_format=$format=str_ireplace('%%title%%',$title,$format);
	if(($_length=smc_strlen(preg_replace('/%%comment%%|%%url%%/','',$_format),$twitter)+$url_length-$length)>0){
		$_temp=smc_substr($_format,0,$length-6-$url_length,'',$twitter).'... - '.$url;
	}else{
		if(smc_strlen($comment,$twitter)>abs($_length)){
			$comment=smc_substr($comment,0,abs($_length)-3,'',$twitter).'...';
		}
		$format=str_ireplace('%%comment%%',$comment,$format);
		$format=str_ireplace('%%url%%',$url,$format);
		$_temp=$format;
	}
	return $_temp;
}
/******************************************/
/***********************/
/************/
function smc_weibo_timeline($args){
	$defaults=array(
		"weibo"=>"",
		"number"=>5,
		"type"=>"user_timeline"
	);
	$r = wp_parse_args( $args, $defaults );
	extract( $r );
	$weibotok = get_option('weibo_access_token');
	$weibos= array_keys($weibotok);
	if(in_array($r['weibo'],$weibos)){
		$tok=$weibotok[$r['weibo']];
		switch($r['weibo']){
			case 'sinaweibo':
					if(!class_exists('WeiboOAuth')){
						include dirname(__FILE__).'/sinaweibo/sinaOAuth.php';
					}
					$data=smc_sina_weibo_timeline($r,$tok);
					break;
			case 'qqweibo':
					if(!class_exists('MBOpenTOAuth')){
						include dirname(__FILE__).'/qqweibo/qqOAuth.php';
					}
					$data=smc_qq_weibo_timeline($r,$tok);
					break;
			case 'sohuweibo':
					if(!class_exists('sohuOAuth')){
						include dirname(__FILE__).'/sohuweibo/sohuOAuth.php';
					}
					$data=smc_sohu_weibo_timeline($r,$tok);
					break;
			case '163weibo':
					if(!class_exists('Weibo163OAuth')){
						include dirname(__FILE__).'/163weibo/163OAuth.php';
					}
					$data=smc_163_weibo_timeline($r,$tok);
					break;
			case 'douban':
					//include dirname(__FILE__).'/douban/doubanOAuth.php';smc_douban_weibo_timeline($r,$tok);break;
			case 'twitter':
					//include dirname(__FILE__).'/twitter/twitterOAuth.php';smc_twitter_weibo_timeline($r,$tok);break;
			default:echo '暂未提供相关功能，请等待插件更新。';return false;
		}
	}else{
		echo '授权异常: 你未绑定你选择的微博或者授权失效，请到后台重新绑定微博';
		return false;
	}
	if($data){
		$output = '<ul>';
		foreach($data as $w){
			$output .= '<li id="smc-'.$w['id'].'" class="smc-weibo"><div class="smc-avatar"><img src="'.$w['avatar'].'" alt="'.$w['author'].'" /></div><div class="smc-author">'.$w['author'].'</div><div class="smc-excerpt">'.$w['text'].'</div></li>';
		}
		$output .='</ul>';
	}
	echo $output;
}