<?php 
class smc_sidebar_login_widget extends WP_Widget{
	function smc_sidebar_login_widget(){
		$widget_des = array('classname'=>'smc_login_widget','description'=>'显示微博连接登陆按钮');
		$this->WP_Widget(false,'社交媒体网站连接登陆',$widget_des);
	}
	function form($instance){
		$instance = wp_parse_args((array)$instance,array(
			'title'=>'社交网站连接登陆',
			'domtag'=>'li'
		));
		echo '<p><label for="'.$this->get_field_name('title').'">标题: <br/><input class="widefat" name="'.$this->get_field_name('title').'" type="text" value="'.htmlspecialchars($instance['title']).'" /></label></p>';
		echo '<p><label for="'.$this->get_field_name('domtag').'">节点标签: <select name="'.$this->get_field_name('domtag').'" class="widefat"><option '.($instance['domtag']=='li'?'selected="selected" ':'').'value="li">li</option><option '.($instance['domtag']=='div'?'selected="selected" ':'').'value="div">div</option></select></label></p>';
	}
	function update($new_instance,$old_instance){
		$instance = $old_instance;
		$instance['title'] = strip_tags(stripslashes($new_instance['title']));
		$instance['domtag'] = strip_tags(stripslashes($new_instance['domtag']));
		return $instance;
	}
	function widget($args,$instance){
		extract($args);
		$title = apply_filters('widget_title',empty($instance['title']) ? '社交网站连接登陆' : $instance['title']);
		$domtag= empty($instance['domtag'])?'li':$instance['domtag'];
		echo "<$domtag id='".$this->get_widget_id()."' class='widget'><h3 class='widget-title'>".$title."</h3>";
		smc_connect('comment=1');
		echo "</$domtag>";
	}
	function get_widget_id() {
		return $this->id_base . '-' . $this->number;
	}
}
class smc_weibo_timeline_widget extends WP_Widget{
	function smc_weibo_timeline_widget(){
		$widget_des = array('classname'=>'smc_login_widget','description'=>'显示你的微博消息');
		$this->WP_Widget(false,'最新微博(by社交媒体连接)',$widget_des);
	}
	function form($instance){
		$instance = wp_parse_args((array)$instance,array(
			'title'=>'我的微博',
			'domtag'=>'li',
			'weibo'=>'',
			'number'=>5,
			'type'=>'user_timeline'
		));
		$weibotok=get_option('weibo_access_token');
		echo '<p><label for="'.$this->get_field_name('title').'">标题: <br/><input class="widefat" name="'.$this->get_field_name('title').'" type="text" value="'.htmlspecialchars($instance['title']).'" /></label></p>';
		echo '<p><label for="'.$this->get_field_name('domtag').'">节点标签: <select name="'.$this->get_field_name('domtag').'" class="widefat"><option '.($instance['domtag']=='li'?'selected="selected" ':'').'value="li">li</option><option '.($instance['domtag']=='div'?'selected="selected" ':'').'value="div">div</option></select></label></p>';
		echo '<p><label for="'.$this->get_field_name('weibo').'">选择微博(你需要先<a href="'.menu_page_url('smc_options',false).'">绑定</a>才能在此选择微博): <select name="'.$this->get_field_name('weibo').'" class="widefat"><option '.(!$instance['weibo']?'selected="selected" ':'').'value="0"></option>';
		if($weibotok){
			foreach($weibotok as $weibo => $tok){
				echo '<option '.($instance['weibo']==$weibo?'selected="selected" ':'').'value="'.$weibo.'">'.smc_get_weibo_name($weibo).'</option>';
			}
		}
		echo '</select></label></p>';
		echo '<p><label for="'.$this->get_field_name('number').'">显示数量: <br/><input class="widefat" name="'.$this->get_field_name('number').'" type="text" value="'.htmlspecialchars($instance['number']).'" /></label></p>';
		echo '<p><label for="'.$this->get_field_name('type').'">消息类型: <select name="'.$this->get_field_name('type').'" class="widefat"><option '.($instance['type']=='user_timeline'?'selected="selected" ':'').'value="user_timeline">我自己的微博列表</option><option '.($instance['type']=='friends_timeline'?'selected="selected" ':'').'value="friends_timeline">我和我关注的人的微博</option><option '.($instance['type']=='public_timeline'?'selected="selected" ':'').'value="public_timeline">所有人的公共微博</option></select></label></p>';
	}
	function update($new_instance,$old_instance){
		$instance = $old_instance;
		$instance['title'] = strip_tags(stripslashes($new_instance['title']));
		$instance['domtag'] = strip_tags(stripslashes($new_instance['domtag']));
		$instance['weibo'] = strip_tags(stripslashes($new_instance['weibo']));
		$instance['number'] = strip_tags(stripslashes($new_instance['number']));
		$instance['type'] = strip_tags(stripslashes($new_instance['type']));
		return $instance;
	}
	function widget($args,$instance){
		extract($args);
		$title = apply_filters('widget_title',empty($instance['title']) ? '我的微博' : $instance['title']);
		$domtag = empty($instance['domtag'])?'li':$instance['domtag'];
		$weibo = empty($instance['weibo'])?'':$instance['weibo'];
		$number = empty($instance['number'])?5:(int)$instance['number'];
		$type = empty($instance['type'])?'user_timeline':$instance['type'];
		echo "<$domtag id='".$this->get_widget_id()."' class='widget'><h3 class='widget-title'>".$title."</h3>";
		smc_weibo_timeline("weibo=$weibo&number=$number&type=$type");
		echo "</$domtag>";
	}
	function get_widget_id() {
		return $this->id_base . '-' . $this->number;
	}
}
function smc_sidebar_widget_init(){
	register_widget('smc_sidebar_login_widget');
	register_widget('smc_weibo_timeline_widget');
}
add_action('widgets_init','smc_sidebar_widget_init');
?>